SAP Netweaver ABAP msg_server.exe Parameter Name Remote Code Execution Vulnerability

2012-06-28T00:00:00
ID ZDI-12-112
Type zdi
Reporter e6af8de8b1d4b2b6d5ba2610cbf9cd38
Modified 2012-11-09T00:00:00

Description

This vulnerability allows remote attackers to execute arbitrary code on vulnerable installations of SAP NetWeaver ABAP. Authentication is not required to exploit this vulnerability.

The specific flaw exists within the way SAP NetWeaver handles packages with opcode 0x43. If a package with sub opcode 0x4 contains a Parameter Name string NetWeaver will eventually write a \x00 byte onto the stack to mark the end of the string. The location of this null byte is dependent on user supplied data and the resulting stack corruption can lead to remote code execution under the context of the running processs.